import React from 'react';
import { createPortal } from 'react-dom';
import url from '../server';

function QuestionnaireResult(props){
    const [resultsFetched, onResultsFetched] = React.useState(null);
    console.log(resultsFetched);
    let dominant_weight = 0;
    let dominant = null;
    let scale_ends = ["Introvert","Extrovert"];
    let display_dominant = 0;

    if(null === resultsFetched)
    {
        fetch(url+"/session/"+props.sessionId) 
        .then(response => response.json())
        .then(result => {
            onResultsFetched(result.results);
        })
        .catch( e => console.error(e));
    }
    else
    {
        let total = 0;
        let max = 0;
        
        resultsFetched.traits.forEach(trait => {
            total += trait.weight;
            if(max < trait.weight)
            {
                max = trait.weight;
                dominant = trait;
            }
            dominant_weight = dominant.weight/total;
        })
        display_dominant = dominant.name === "Introvert" ? dominant_weight : 1-dominant_weight
    }
    return(
        <React.Fragment>
        <div className="gradient bordered" 
        style={{
            "--data-weight": display_dominant*100+"%",
            "--data-grad-offset": display_dominant*100+1+"%",
            }}>
            <div className="display_flex flex_horizontal space_between position_static fill_width">
            <div>Introvert</div>
            <div>Extrovert</div>
            </div>
            <div className="display_flex position_static fill_width center">
            {resultsFetched ? (dominant_weight*100).toFixed(1)+"% "+dominant.name : "Results loading"}
            </div>
        </div>
        {null != dominant &&
        <div>
            🎉{dominant.description}
        </div>
        }
        </React.Fragment>
    )
}

export default QuestionnaireResult;